﻿using System;

class BSearchApp
{
    static void Main(string[] args)
    {
        int[] dat = { 22, 65, 72, 17, 48, 50, 39, 90, 80 };
        
        BasicSort(dat, dat.Length); //ソート済みデータを作成

        for (int i = 0; i < dat.Length; i++)
            Console.Write("{0,4}", dat[i]);
        Console.WriteLine();

        int searchData = 48;
        int index = BinarySearch(dat, dat.Length, searchData);  //二分探索(「48」を探す)

        if (index < 0)
            Console.WriteLine("target={0}はありません。");
        else
            Console.WriteLine("target={0}は {1}番目にあります。", searchData, index + 1);
    }

    //  以下のコード断片は、C# コンパイラと Java コンパイラのどちらでも有効な実装です。 

    //==== ==== ★★二分探索本体★★ ==== ==== 
    //  [] dat ---- ソート対象の配列本体
    //  n      ---- 要素の数(2以上であることが前提)
    //  target ---- 検索したい値
    private static int BinarySearch(int[] dat, int n, int target) {
        for (int p = 0, q = n - 1; p <= q; ) {
            int w = (p + q) / 2;
            if (dat[w] == target)
                return w;   //検索結果
            else if (dat[w] < target)
                p = w;
            else
                q = w;
        }
        return -1;          //見つからなかった場合は、-1を返すことにする
    }

    //  [] dat ---- ソート対象の配列本体
    //  n      ---- 要素の数(2以上であることが前提)
    private static void BasicSort(int[] dat, int n) {
        for (int j = 0; j < n - 1; j++) {
            int minpos = j;
            for (int k = j + 1; k < n; k++) {
                if (dat[minpos] > dat[k])
                    minpos = k;
            }
            int w = dat[j];
            dat[j] = dat[minpos];
            dat[minpos] = w;
        }
    }

    //==== ==== ★★ ★★ ==== ==== 
}

