﻿using System;

class QSortApp
{
    static void Main(string[] args)
    {
        int[] dat = { 22, 65, 72, 17, 48, 50, 39, 90, 80 };

        for (int i = 0; i < dat.Length; i++)
            Console.Write("{0,4}", dat[i]);
        Console.WriteLine();

        QuickSort(dat, 0, dat.Length - 1);   //クイックソート

        for (int i = 0; i < dat.Length; i++)
            Console.Write("{0,4}", dat[i]);
        Console.WriteLine();
    }

    //  以下のコード断片は、C# コンパイラと Java コンパイラのどちらでも有効な実装です。 

    //==== ==== ★★クイックソート本体★★ ==== ==== 
    //  [] dat ---- ソート対象の配列本体
    //  p, q   ---- 分割を行う範囲(添え字が p から q の範囲)
    //              再帰呼び出しによって、さらに分割するので p から q までが結果的にソートされる
    private static void QuickSort(int[] dat, int p, int q) {
        int i, j, pivot, w;
        i = p;                     //左端からピボット値と比較する位置
        j = q;                     //右端からピボット値と比較する位置
        pivot = dat[(p + q) / 2];  //ピボットの算出

        // i と j がひっくり返るまで以下のループを続ける
        while (i < j) {
            while (dat[i] < pivot) i++;  //左半分の中から、右に行くべき値を見つける
            while (dat[j] > pivot) j--;  //右半分の中から、左に行くべき値をみつける
            if (i < j) {
                // i と j がひっくりかえってなければ(i < j) ならば、交換する
                w = dat[i];
                dat[i] = dat[j];
                dat[j] = w;
                // i と j をそれぞれ進める
                i++;
                j--;
            }
            else if (i == j) {
                // i と j が等しいときは交換はしないが、i と j をそれぞれ進める
                i++;
                j--;
            }
        }
        // さらに左右をそれぞれ分割する
        if (p < j) QuickSort(dat, p, j);  //左半分の要素が2つ以上あるときは、さらに分割
        if (i < q) QuickSort(dat, i, q);  //右半分の要素が2つ以上あるときは、さらに分割
    }
    //==== ==== ★★ ★★ ==== ==== 
}
